Ipopt 3.12.10

- Main Page
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

All Classes Namespaces Files Functions Variables Typedefs Enumerations Enumerator Friends Macros
Public Member Functions | Private Attributes | List of all members
Ipopt::LowRankUpdateSymMatrix Class Reference

Class for symmetric matrices, represented as low-rank updates. More...

`#include <IpLowRankUpdateSymMatrix.hpp>`

Inheritance diagram for Ipopt::LowRankUpdateSymMatrix:
[legend]

## Public Member Functions
void | SetDiag (const Vector &D)
| Method for setting the diagonal elements (as a Vector). More...
SmartPtr< const Vector > | GetDiag () const
| Method for getting the diagonal elements. More...
void | SetV (const MultiVectorMatrix &V)
| Method for setting the positive low-rank update part. More...
SmartPtr< const MultiVectorMatrix > | GetV () const
| Method for getting the positive low-rank update part. More...
void | SetU (const MultiVectorMatrix &U)
| Method for setting the negative low-rank update part. More...
SmartPtr< const MultiVectorMatrix > | GetU () const
| Method for getting the negative low-rank update part. More...
SmartPtr< const Matrix > | P_LowRank () const
| Return the expansion matrix to lift the low-rank update to the higher-dimensional space. More...
SmartPtr< const VectorSpace > | LowRankVectorSpace () const
| Return the vector space in with the low-rank update vectors live. More...
bool | ReducedDiag () const
| Flag indicating whether the diagonal term lives in the smaller space (from P_LowRank) or in the full space. More...
Constructors / Destructors
| LowRankUpdateSymMatrix (const LowRankUpdateSymMatrixSpace *owner_space)
| Constructor, given the corresponding matrix space. More...
| ~LowRankUpdateSymMatrix ()
| Destructor. More...
Public Member Functions inherited from Ipopt::SymMatrix
SmartPtr< const SymMatrixSpace > | OwnerSymMatrixSpace () const
| SymMatrix (const SymMatrixSpace *owner_space)
| Constructor, taking the owner_space. More...
virtual | ~SymMatrix ()
| Destructor. More...
Index | Dim () const
| Dimension of the matrix (number of rows and columns) More...
Public Member Functions inherited from Ipopt::Matrix
bool | HasValidNumbers () const
| Method for determining if all stored numbers are valid (i.e., no Inf or Nan). More...
SmartPtr< const MatrixSpace > | OwnerSpace () const
| Return the owner MatrixSpace. More...
| Matrix (const MatrixSpace *owner_space)
| Constructor. More...
virtual | ~Matrix ()
| Destructor. More...
void | MultVector (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix-vector multiply. More...
void | TransMultVector (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix(transpose) vector multiply. More...
void | AddMSinvZ (Number alpha, const Vector &S, const Vector &Z, Vector &X) const
| X = X + alpha*(Matrix S^{-1} Z). More...
void | SinvBlrmZMTdBr (Number alpha, const Vector &S, const Vector &R, const Vector &Z, const Vector &D, Vector &X) const
| X = S^{-1} (r + alpha*Z*M^Td). More...
Index | NRows () const
| Number of rows. More...
Index | NCols () const
| Number of columns. More...
void | ComputeRowAMax (Vector &rows_norms, bool init=true) const
| Compute the max-norm of the rows in the matrix. More...
void | ComputeColAMax (Vector &cols_norms, bool init=true) const
| Compute the max-norm of the columns in the matrix. More...
virtual void | Print (SmartPtr< const Journalist > jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent=0, const std::string &prefix="") const
| Print detailed information about the matrix. More...
virtual void | Print (const Journalist &jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent=0, const std::string &prefix="") const
Public Member Functions inherited from Ipopt::TaggedObject
| TaggedObject ()
| Constructor. More...
virtual | ~TaggedObject ()
| Destructor. More...
Tag | GetTag () const
| Users of TaggedObjects call this to update their own internal tags every time they perform the expensive operation. More...
bool | HasChanged (const Tag comparison_tag) const
| Users of TaggedObjects call this to check if the object HasChanged since they last updated their own internal tag. More...
Public Member Functions inherited from Ipopt::ReferencedObject
| ReferencedObject ()
virtual | ~ReferencedObject ()
Index | ReferenceCount () const
void | AddRef (const Referencer *referencer) const
void | ReleaseRef (const Referencer *referencer) const
Public Member Functions inherited from Ipopt::Subject
| Subject ()
| Default Constructor. More...
virtual | ~Subject ()
| Default destructor. More...
void | AttachObserver (Observer::NotifyType notify_type, Observer *observer) const
| Attach the specified observer (i.e., begin recieving notifications). More...
void | DetachObserver (Observer::NotifyType notify_type, Observer *observer) const
| Detach the specified observer (i.e., no longer recieve notifications). More...

## Protected Member Functions
Methods overloaded from matrix
virtual void | MultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const
| Matrix-vector multiply. More...
virtual bool | HasValidNumbersImpl () const
| Method for determining if all stored numbers are valid (i.e., no Inf or Nan). More...
virtual void | ComputeRowAMaxImpl (Vector &rows_norms, bool init) const
| Compute the max-norm of the rows in the matrix. More...
virtual void | ComputeColAMaxImpl (Vector &cols_norms, bool init) const
| Since the matrix is symmetric, the row and column max norms are identical. More...
virtual void | PrintImpl (const Journalist &jnlst, EJournalLevel level, EJournalCategory category, const std::string &name, Index indent, const std::string &prefix) const
| Print detailed information about the matrix. More...
Protected Member Functions inherited from Ipopt::SymMatrix
virtual void | TransMultVectorImpl (Number alpha, const Vector &x, Number beta, Vector &y) const
| Since the matrix is symmetric, it is only necessary to implement the MultVectorImpl method in a class that inherits from this base class. More...
Protected Member Functions inherited from Ipopt::Matrix
virtual void | AddMSinvZImpl (Number alpha, const Vector &S, const Vector &Z, Vector &X) const
| X = X + alpha*(Matrix S^{-1} Z). More...
virtual void | SinvBlrmZMTdBrImpl (Number alpha, const Vector &S, const Vector &R, const Vector &Z, const Vector &D, Vector &X) const
| X = S^{-1} (r + alpha*Z*M^Td). More...
Protected Member Functions inherited from Ipopt::TaggedObject
void | ObjectChanged ()
| Objects derived from TaggedObject MUST call this method every time their internal state changes to update the internal tag for comparison. More...
Protected Member Functions inherited from Ipopt::Subject
void | Notify (Observer::NotifyType notify_type) const

## Private Member Functions
Default Compiler Generated Methods
(Hidden to avoid implicit creation/calling). These methods are not implemented and we do not want the compiler to implement them for us, so we declare them private and do not define them. This ensures that they will not be implicitly created/called.
| LowRankUpdateSymMatrix ()
| Default Constructor. More...
| LowRankUpdateSymMatrix (const LowRankUpdateSymMatrix &)
| Copy Constructor. More...
void | operator= (const LowRankUpdateSymMatrix &)
| Overloaded Equals Operator. More...

## Private Attributes
SmartPtr< const LowRankUpdateSymMatrixSpace > | owner_space_
| corresponding matrix space More...
SmartPtr< const Vector > | D_
| Vector storing the diagonal matrix D. More...
SmartPtr< const MultiVectorMatrix > | V_
| Vector storing the positive low-rank update. More...
SmartPtr< const MultiVectorMatrix > | U_
| Vector storing the negative low-rank update. More...

## Additional Inherited Members
Public Types inherited from Ipopt::TaggedObject
typedef unsigned int | Tag
| Type for the Tag values. More...

## Detailed Description

Class for symmetric matrices, represented as low-rank updates.

The matrix M is represented as M = P_LR(D + V V^T - U U^T)P_LR^T (if reduced_diag is true), or M = D + P_LR(V V^T - U U^T)P_LR^T (if reduced_diag is false). D is a diagonal matrix, and V and U are MultiVectorMatrices, and P_LR is an ExpansionMatrix. The vectors in the low-rank update (before expansion) live in the LowRankVectorSpace. If P_LR is NULL, P_LR is assumed to be the identity matrix. If V or U is NULL, it is assume to be a matrix of zero columns.

Definition at line 31 of file IpLowRankUpdateSymMatrix.hpp.

## Constructor & Destructor Documentation

Ipopt::LowRankUpdateSymMatrix::LowRankUpdateSymMatrix | ( | const LowRankUpdateSymMatrixSpace * | owner_space | ) |

Constructor, given the corresponding matrix space.

Ipopt::LowRankUpdateSymMatrix::~LowRankUpdateSymMatrix | ( |  | ) |

Destructor.

Ipopt::LowRankUpdateSymMatrix::LowRankUpdateSymMatrix | ( |  | ) |
| private

Default Constructor.

Ipopt::LowRankUpdateSymMatrix::LowRankUpdateSymMatrix | ( | const LowRankUpdateSymMatrix & |  | ) |
| private

Copy Constructor.

## Member Function Documentation

void Ipopt::LowRankUpdateSymMatrix::SetDiag | ( | const Vector & | D | ) |
| inline

Method for setting the diagonal elements (as a Vector).

Definition at line 46 of file IpLowRankUpdateSymMatrix.hpp.

SmartPtr<const Vector> Ipopt::LowRankUpdateSymMatrix::GetDiag | ( |  | ) | const
| inline

Method for getting the diagonal elements.

Definition at line 53 of file IpLowRankUpdateSymMatrix.hpp.

void Ipopt::LowRankUpdateSymMatrix::SetV | ( | const MultiVectorMatrix & | V | ) |
| inline

Method for setting the positive low-rank update part.

Definition at line 59 of file IpLowRankUpdateSymMatrix.hpp.

SmartPtr<const MultiVectorMatrix> Ipopt::LowRankUpdateSymMatrix::GetV | ( |  | ) | const
| inline

Method for getting the positive low-rank update part.

Definition at line 66 of file IpLowRankUpdateSymMatrix.hpp.

void Ipopt::LowRankUpdateSymMatrix::SetU | ( | const MultiVectorMatrix & | U | ) |
| inline

Method for setting the negative low-rank update part.

Definition at line 72 of file IpLowRankUpdateSymMatrix.hpp.

SmartPtr<const MultiVectorMatrix> Ipopt::LowRankUpdateSymMatrix::GetU | ( |  | ) | const
| inline

Method for getting the negative low-rank update part.

Definition at line 79 of file IpLowRankUpdateSymMatrix.hpp.

SmartPtr< const Matrix > Ipopt::LowRankUpdateSymMatrix::P_LowRank | ( |  | ) | const
| inline

Return the expansion matrix to lift the low-rank update to the higher-dimensional space.

Definition at line 237 of file IpLowRankUpdateSymMatrix.hpp.

SmartPtr< const VectorSpace > Ipopt::LowRankUpdateSymMatrix::LowRankVectorSpace | ( |  | ) | const
| inline

Return the vector space in with the low-rank update vectors live.

Definition at line 243 of file IpLowRankUpdateSymMatrix.hpp.

bool Ipopt::LowRankUpdateSymMatrix::ReducedDiag | ( |  | ) | const
| inline

Flag indicating whether the diagonal term lives in the smaller space (from P_LowRank) or in the full space.

Definition at line 249 of file IpLowRankUpdateSymMatrix.hpp.

virtual void Ipopt::LowRankUpdateSymMatrix::MultVectorImpl | ( | Number | alpha,
|  | const Vector & | x,
|  | Number | beta,
|  | Vector & | y
| ) |  | const
| protected virtual

Matrix-vector multiply.

Computes y = alpha * Matrix * x + beta * y

Implements Ipopt::Matrix.

virtual bool Ipopt::LowRankUpdateSymMatrix::HasValidNumbersImpl | ( |  | ) | const
| protected virtual

Method for determining if all stored numbers are valid (i.e., no Inf or Nan).

Reimplemented from Ipopt::Matrix.

virtual void Ipopt::LowRankUpdateSymMatrix::ComputeRowAMaxImpl | ( | Vector & | rows_norms,
|  | bool | init
| ) |  | const
| protected virtual

Compute the max-norm of the rows in the matrix.

The result is stored in rows_norms. The vector is assumed to be initialized.

Implements Ipopt::Matrix.

virtual void Ipopt::LowRankUpdateSymMatrix::ComputeColAMaxImpl | ( | Vector & | cols_norms,
|  | bool | init
| ) |  | const
| protected virtual

Since the matrix is symmetric, the row and column max norms are identical.

Reimplemented from Ipopt::SymMatrix.

virtual void Ipopt::LowRankUpdateSymMatrix::PrintImpl | ( | const Journalist & | jnlst,
|  | EJournalLevel | level,
|  | EJournalCategory | category,
|  | const std::string & | name,
|  | Index | indent,
|  | const std::string & | prefix
| ) |  | const
| protected virtual

Print detailed information about the matrix.

Implements Ipopt::Matrix.

void Ipopt::LowRankUpdateSymMatrix::operator= | ( | const LowRankUpdateSymMatrix & |  | ) |
| private

Overloaded Equals Operator.

## Member Data Documentation

SmartPtr<const LowRankUpdateSymMatrixSpace> Ipopt::LowRankUpdateSymMatrix::owner_space_
| private

corresponding matrix space

Definition at line 138 of file IpLowRankUpdateSymMatrix.hpp.

SmartPtr<const Vector> Ipopt::LowRankUpdateSymMatrix::D_
| private

Vector storing the diagonal matrix D.

Definition at line 141 of file IpLowRankUpdateSymMatrix.hpp.

SmartPtr<const MultiVectorMatrix> Ipopt::LowRankUpdateSymMatrix::V_
| private

Vector storing the positive low-rank update.

Definition at line 144 of file IpLowRankUpdateSymMatrix.hpp.

SmartPtr<const MultiVectorMatrix> Ipopt::LowRankUpdateSymMatrix::U_
| private

Vector storing the negative low-rank update.

Definition at line 147 of file IpLowRankUpdateSymMatrix.hpp.

The documentation for this class was generated from the following file:

- src/LinAlg/IpLowRankUpdateSymMatrix.hpp